/*
	setup.cmd
	(c) 2003 by Don Eitner

	This is a setup utility to help inexperienced users set default values for smartbackup.conf.
*/

ProgName = 'SmartBackup'
ProgVersion = 1.1
Questions = 16
QNum = 1
CALL SysCls

CALL AnsiSetup

IF Stream('smartbackup.conf', 'c', 'query exists') <> '' THEN
	DO
		SAY LBro||BRed||'NOTE: Proceeding with this setup utility will delete the file smartbackup.conf'
		SAY 'if it exists.  Do you wish to continue?'||Non
			YesNo = SysGetKey(ECHO)
		IF Translate(YesNo) = 'N' THEN
			EXIT
	END

DO UNTIL OutputDir <> ''
	SAY LGre||ProgName ProgVersion 'Setup Program'||Non
	SAY
	SAY LWhi||'Step' QNum 'of' Questions||Non
	SAY 'SmartBackup project files are small and will be written to the TEMP directory'
	SAY 'as set in config.sys.  Some post-processing scripts (such as pp_zip2iso.cmd)'
	SAY 'also need to create temporary files on your hard disk, but these files could'
	SAY 'require as much space as your output disc size (eg. 700MB if you are sorting'
	SAY 'files to fit onto CD-R discs).'
	SAY 'What is the drive and directory where such large files should be placed?'
	PARSE PULL OutputDir
	CurDir = Directory()
	NewDir = Directory(OutputDir)
	IF NewDir = CurDir THEN
		DO
			SAY 'Unable to locate' OutputDir
			OutputDir = ''
		END
	NewDir = Directory(CurDir)
END

QNum = QNum + 1
CALL SysCls

DO UNTIL DataType(DiscSize) = 'NUM' & (Translate(Unit) = 'MB' | Translate(Unit) = 'KB')
	SAY LGre||ProgName ProgVersion 'Setup Program'||Non
	SAY
	SAY LWhi||'Step' QNum 'of' Questions||Non
	SAY 'You may create multiple configuration files (eg. smartbackup.conf) each with'
	SAY 'a different set of default values for SmartBackup.  For the initial'
	SAY 'configuration file, what is the default output disc size?  Enter this as the'
	SAY 'number (ie. 700 for CD-R, 100 for Zip disk) then a space, then the unit of'
	SAY 'measure (MB or KB).'
	SAY LTur||'To accept the default of 700 MB, press [ENTER] now,'||Non 'or type a capacity.'
	PARSE PULL DiscSize Unit
	IF DiscSize = '' THEN
		DiscSize = 700
	IF Unit = '' THEN
		UNIT = 'MB'
END

QNum = QNum + 1
CALL SysCls

DO UNTIL Translate(Recurse) = 'YES' | Translate(Recurse) = 'NO'
	SAY LGre||ProgName ProgVersion 'Setup Program'||Non
	SAY
	SAY LWhi||'Step' QNum 'of' Questions||Non
	SAY 'By default,' ProgName 'works on complete directory trees, including sub-'
	SAY 'directories.'
	SAY LTur||'If you wish this behavior, press [ENTER] now,'||Non 'otherwise type NO.'
	PARSE PULL Recurse
	IF Recurse = '' THEN
		Recurse = 'YES'
END

QNum = QNum + 1
CALL SysCls

DO UNTIL Translate(EmptyDirs) = 'YES' | Translate(EmptyDirs) = 'NO'
	SAY LGre||ProgName ProgVersion 'Setup Program'||Non
	SAY
	SAY LWhi||'Step' QNum 'of' Questions||Non
	SAY 'By default,' ProgName 'does not include empty directories in its backup'
	SAY 'projects.  Sometimes you may want to back them up (such as when backing up'
	SAY 'OS/2 desktop archive directories) but by default' ProgName 'does not.'
	SAY LTur||'If you wish this behavior, press [ENTER] now,'||Non 'otherwise type YES.'
	PARSE PULL EmptyDirs
	IF EmptyDirs = '' THEN
		EmptyDirs = 'NO'
END

QNum = QNum + 1
CALL SysCls

DO UNTIL DataType(MinSize) = 'NUM' | MinSize = ''
	SAY LGre||ProgName ProgVersion 'Setup Program'||Non
	SAY
	SAY LWhi||'Step' QNum 'of' Questions||Non
	SAY 'If you wish to set a minimum file size, enter it now.  This is the smallest'
	SAY 'size file that SmartBackup will handle and should be given in the same unit'
	SAY 'of measure as the default disc size (ie. if you said 250 MB for the disc'
	SAY 'size, then give the minimum file size in MB but DO NOT add MB to this line.'
	SAY LTur||'If you wish to use the default of 0 (no minimum size) press [ENTER[ now,'||Non
	SAY 'or type a value in' Unit||'.'
	PARSE PULL MinSize
	IF Pos('MB', Translate(MinSize)) > 0 THEN
		MinSize = Substr(MinSize, 1, Pos('MB', Translate(MinSize) - 1))
	IF Pos('KB', Translate(MinSize)) > 0 THEN
		MinSize = Substr(MinSize, 1, Pos('KB', Translate(MinSize) - 1))
END

QNum = QNum + 1
CALL SysCls

DO UNTIL DataType(MaxSize) = 'NUM' | MaxSize = ''
	SAY LGre||ProgName ProgVersion 'Setup Program'||Non
	SAY
	SAY LWhi||'Step' QNum 'of' Questions||Non
	SAY 'If you wish to set a maximum file size, enter it now.  This is the largest'
	SAY 'size file that SmartBackup will handle and should be given in the same unit'
	SAY 'of measure as the default disc size (ie. if you said 250 MB for the disc'
	SAY 'size, then give the maximum file size in MB but DO NOT add MB to this line.'
	SAY LTur||'If you wish to use the default of infinite (no maximum size) press [ENTER[ now,'||Non
	SAY 'or type a value in' Unit||'.'
	PARSE PULL MaxSize
	IF Pos('MB', Translate(MaxSize)) > 0 THEN
		MaxSize = Substr(MaxSize, 1, Pos('MB', Translate(MaxSize) - 1))
	IF Pos('KB', Translate(MaxSize)) > 0 THEN
		MaxSize = Substr(MaxSize, 1, Pos('KB', Translate(MaxSize) - 1))
END

QNum = QNum + 1
CALL SysCls

DO UNTIL DataType(AllocationUnit) = 'NUM'
	SAY LGre||ProgName ProgVersion 'Setup Program'||Non
	SAY
	SAY LWhi||'Step' QNum 'of' Questions||Non
	SAY 'For accurate calculation of available disk space,' ProgName 'needs to'
	SAY 'know the allocation unit size of your output discs.  The default is 2048'
	SAY 'bytes which is the standard for CD-R discs.  However if you will be'
	SAY 'backing up to removable hard drives (Zip, Jaz, Orb, etc) then this should'
	SAY 'be set to 512 bytes.'
	SAY LTur||'To accept the CD-R default of 2048, press [ENTER] now,'||Non 'otherwise type the'
	SAY 'size in bytes (number only, please).'
	PARSE PULL AllocationUnit
	IF AllocationUnit = '' THEN
		AllocationUnit = 2048
ENd

QNum = QNum + 1
CALL SysCls

DO UNTIL VolumeID <> ''
	SAY LGre||ProgName ProgVersion 'Setup Program'||Non
	SAY
	SAY LWhi||'Step' QNum 'of' Questions||Non
	SAY 'When you backup files to a CD, DVD or other removable drive, you can set a'
	SAY 'name for the volume (eg. Backup or WorkFile, etc).  This name should be no'
	SAY 'more than about 11 characters (including spaces).  This volume name may'
	SAY 'also be used by post-processing scripts to name their temporary files.'
	SAY LTur||'Default volume name is Backup.  To accept this, press [ENTER] now.'||Non
	PARSE PULL VolumeID
	IF VolumeID = '' THEN
		VolumeID = 'Backup'
END

QNum = QNum + 1
CALL SysCls

DO
	SAY LGre||ProgName ProgVersion 'Setup Program'||Non
	SAY
	SAY LWhi||'Step' QNum 'of' Questions||Non
	SAY 'Please enter the full path and file name to your mkisofs.exe program.'
	SAY LTur||'If you do not have and will not be using mkisofs to create CD images,'
	SAY 'press [ENTER] now.'||Non
	PARSE PULL ISOProg
	IF ISOProg <> '' THEN
		DO WHILE Stream(ISOProg, 'c', 'query exists') = ''
			SAY 'Unable to locate' ISOProg
			SAY 'Please enter the path to mkisofs.exe or press [ENTER] to skip.'
			PARSE PULL ISOProg
			IF ISOProg = '' THEN
				LEAVE
		END
END

IF ISOProg = '' THEN
	DO
		SAY 'Skipping mkisofs related questions.'
		CALL SysSleep 1
		QNum = QNum + 1
		CALL SysCls
	END
ELSE
	DO
		QNum = QNum + 1
		CALL SysCls

		SAY LGre||ProgName ProgVersion 'Setup Program'||Non
		SAY
		SAY LWhi||'Step' QNum 'of' Questions||Non
		SAY 'If you wish to use any special mkisofs parameters, enter them now as you would'
		SAY 'on the mkisofs command line (ie. all on one line, complete with option and'
		SAY 'value).'  LTur||'If you do not know or do not understand the mkisofs parameters, I can'
		SAY 'choose reasonable default values for you.  If you wish me to do this, press'
		SAY '[ENTER] now.'||Non
		PARSE PULL ISOAdditional
		IF ISOAdditional = '' THEN
			ISOAdditional = '-graft-points -l -J -r -D -T'
	END

QNum = QNum + 1
CALL SysCls

DO
	SAY LGre||ProgName ProgVersion 'Setup Program'||Non
	SAY
	SAY LWhi||'Step' QNum 'of' Questions||Non
	SAY 'Please enter the full path and filename to your cdrecord.exe program.'
	SAY LTur||'If you do not have and will not be using cdrecord to record CD images,'
	SAY 'press [ENTER] now.'||Non
	PARSE PULL CDRProg
	IF CDRProg <> '' THEN
		DO WHILE Stream(CDRProg, 'c', 'query exists') = ''
			SAY 'Unable to locate' CDRProg
			SAY 'Please enter the path to cdrecord.exe or press [ENTER] to skip.'
			PARSE PULL CDRProg
			IF CDRProg = '' THEN
				LEAVE
		END
END

IF CDRProg = '' THEN
	DO
		SAY 'Skipping cdrecord related questions.'
		CALL SysSleep 1
		QNum = QNum + 4
		CALL SysCls
	END
ELSE
	DO
		QNum = QNum + 1
		CALL SysCls

		SAY LGre||ProgName ProgVersion 'Setup Program'||Non
		SAY
		SAY LWhi||'Step' QNum 'of' Questions||Non
		SAY 'The post-processing scripts for writing data to CD-R need to know the SCSI'
		SAY 'address of your CD recorder.  Even for IDE drives this is given as a SCSI'
		SAY 'address such as 0,1,0.  You can find this address using the command:'
		SAY 'cdrecord -scanbus'
		SAY 'or with Data-CD-Creator.  The former provides far more information that you.'
		SAY 'probably need but the latter requires you to install Data-CD-Creator.'
		SAY LTur||'If you are not going to be recording to CD, just press [ENTER] now.'||Non
		PARSE PULL CDRDevice
		IF CDRDevice = '' THEN
			CDRDevice = '0,1,0'

		QNum = QNum + 1
		CALL SysCls

		DO UNTIL DataType(CDRSpeed) = 'NUM'
			SAY LGre||ProgName ProgVersion 'Setup Program'||Non
			SAY
			SAY LWhi||'Step' QNum 'of' Questions||Non
			SAY 'What is the maximum write speed supported by your CD-R drive?  Note that'
			SAY 'you should only set this as high as the LESSER speed rating of either'
			SAY 'your CD-R drive or the CD-R discs you will use (ie. if using a 24X writer'
			SAY 'with 52X media, set this to no more than 24X).'
			PARSE PULL CDRSpeed
			IF Translate(Right(CDRSpeed, 1)) = 'X' THEN
				CDRSpeed = Left(CDRSpeed, Pos('X', Translate(CDRSpeed)) - 1)
		END

		QNum = QNum + 1
		CALL SysCls

		DO
			SAY LGre||ProgName ProgVersion 'Setup Program'||Non
			SAY
			SAY LWhi||'Step' QNum 'of' Questions||Non
			SAY 'When using a post-processing script which records to CD-R, it is sometimes'
			SAY 'helpful to setup an additional memory buffer to prevent buffer underruns'
			SAY 'which can ruin a CD.  How many MB of your system memory would you like to'
			SAY 'use for this purspose?  Note that this additional buffer will only be used'
			SAY 'while recording a CD.' LTur||'To use a default of 4 MB just press [ENTER] now,'||Non
			SAY 'otherwise enter a whole number between 4 and 32.'
			PARSE PULL CDRBuffer
			IF CDRBuffer = '' THEN
				CDRBuffer = 4
			IF DataType(CDRBuffer) = 'NUM' & CDRBuffer >= 4 & CDRBuffer <= 32 THEN
				CDRBuffer = CDRBuffer||'m'
		END

		QNum = QNum + 1
		CALL SysCls

		DO
			SAY LGre||ProgName ProgVersion 'Setup Program'||Non
			SAY
			SAY LWhi||'Step' QNum 'of' Questions||Non
			SAY 'If you wish to use any special cdrecord paramters, enter them now as you would'
			SAY 'on the cdrecord command line (ie. all on one line, complete with option and'
			SAY ' value).'  LTur||'If you do not know or do not understand the cdrecord parameters, I'
			SAY 'can choose reasonable default values for you.  If you wish me to do this,'
			SAY 'press [ENTER] now.'||Non
			PARSE PULL CDRAdditional
			IF CDRAdditional = '' THEN
				CDRAdditional = '-v -eject driveropts=burnfree'
		END
	END

QNum = QNum + 1
CALL SysCls

SAY LGre||ProgName ProgVersion 'Setup Program'||Non
SAY
SAY LWhi||'Step' QNum 'of' Questions||Non
SAY ProgName 'PM requires the file drctl014.dll to be placed somewhere in your'
SAY 'LIBPATH.  Please enter the directory where you would like drctl014.dll to be'
SAY 'placed, or press [ENTER] now if you already have this file on your system.'
SAY 'NOTE:  If you installed SmartBackup via. WarpIn, you already installed this'
SAY 'file, so press [ENTER] to skip further processing.'
PARSE PULL DLLPath
CurDir = Directory()
IF DLLPath <> CurDir & DLLPath <> '' THEN
	DO
		NewDir = Directory(DLLPath)
		DO WHILE NewDir = CurDir
			SAY 'Unable to locate' DLLPath||'.  Please try again.'
			PARSE PULL DLLPath
			NewDir = Directory(DLLPath)
		END
		NewDir = Directory(CurDir)
		COPY '\os2\dll\drctl014.*' DLLPath
	END

CALL EditConf

EXIT


AnsiSetup:
	Esc=d2c(27)d2c(91)

	/* Attributes */
	Hig=Esc'1m'
	Non=Esc'0m'

	/* Foreground Colors */
	Bla=Esc'30m'
	Red=Esc'31m'
	Gre=Esc'32m'
	Bro=Esc'33m'
	Blu=Esc'34m'
	Pur=Esc'35m'
	Tur=Esc'36m'
	Whi=Esc'37m'
	LBla=Hig||Bla
	LRed=Hig||Red
	LGre=Hig||Gre
	LBro=Hig||Bro
	LBlu=Hig||Blu
	LPur=Hig||Pur
	LTur=Hig||Tur
	LWhi=Hig||Whi

	/* Background Colors */
	BBla=Esc'40m'
	BRed=Esc'41m'
	BGre=Esc'42m'
	BBro=Esc'43m'
	BBlu=Esc'44m'
	BCya=Esc'45m'
	BTur=Esc'46m'
	BWhi=Esc'47m'
RETURN


EditConf:
	SBCDef = 'default.conf'
	SBConf = 'smartbackup.conf'

	/* To avoid problems, delete existing smartbackup.conf if it exists */
	IF Stream(SBConf, 'c', 'query exists') <> '' THEN
		RC = SysFileDelete(SBConf)

	/* Read global configuration file into variables */
	RC = Stream(SBCDef, 'c', 'open read')
	RC = Stream(SBConf, 'c', 'open write')
	DO WHILE Lines(SBCDef) > 0
		InLine = Linein(SBCDef, , 1)
		IF Left(InLine, 2) = '/*' | Left(InLine, 2) = '*/' | InLine = '' THEN
			CALL Lineout SBConf, InLine
		ELSE
			SELECT
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'OUTPUTDIR' THEN
					CALL LineOut SBConf, 'OutputDir='||OutputDir
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'DISCSIZE' THEN
					CALL LineOut SBConf, 'DiscSize='||DiscSize
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'UNIT' THEN
					CALL LineOut SBConf, 'Unit='||Unit
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'RECURSE' THEN
					CALL LineOut SBConf, 'Recurse='||Recurse
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'EMPTYDIRS' THEN
					CALL LineOut SBConf, 'EmptyDirs='||EmptyDirs
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'MINSIZE' THEN
					CALL LineOut SBConf, 'MinSize='||MinSize
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'MAXSIZE' THEN
					CALL LineOut SBConf, 'MaxSize='||MaxSize
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'AllocationUnit' THEN
					CALL LineOut SBConf, 'AllocationUnit='||AllocationUnit
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'VOLUMEID' THEN
					CALL LineOut SBConf, 'VolumeID='||VolumeID
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'ISOPROG' THEN
					CALL LineOut SBConf, 'ISOProg='||ISOProg
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'ISOADDITIONAL' THEN
					CALL LineOut SBConf, 'ISOAdditional='||ISOAdditional
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'CDRPROG' THEN
					CALL LineOut SBConf, 'CDRProg='||CDRProg
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'CDRSPEED' THEN
					CALL LineOut SBConf, 'CDRSpeed='||CDRSpeed
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'CDRDEVICE' THEN
					CALL LineOut SBConf, 'CDRDevice='||CDRDevice
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'CDRBUFFER' THEN
					CALL LineOut SBConf, 'CDRBuffer='||CDRBuffer
				WHEN Translate(Left(InLine, Pos('=', InLine) - 1)) = 'CDRADDITONAL' THEN
					CALL LineOut SBConf, 'CDRAdditional='||CDRAdditional
				OTHERWISE
					CALL Lineout SBConf, InLine
			END
	END
	RC = Stream(SBConf, 'c', 'close')
	RC = Stream(SBCDef, 'c', 'close')
RETURN

